#!/ussr/bin/env apl --script

⍝ © 1981-1983 2023-2024 LAAS CNRS, Toulouse, France
⍝ Use of this software is governed by the MIT licence
⍝ Author Bernard Berthomieu, LAAS CNRS, Toulouse, France

VERSION←'1.0'

∇P ADDNEXT p                      
 ⍝ AJOUT NOUVEAU SUIVANT A UN ETAT
 sg[1 4 ;P; (,sg[2;P;])⍳TR]←p,REC
∇

∇B ← ALPHAS P;X                          
 ⍝ donne vecteur bornes inf pour etats p;
 B ← 0⍴0
 →(0=X←st[3;P])/0
 B ← id[st[2;P]+¯1+⍳X]
∇

∇B ← BETAS P;X                          
 ⍝ donne vecteur bornes sup pour etat p;
 B ← 0⍴0
 →(0=X←st[3;P])/0
 B ← id[st[2;P]+X+¯1+⍳X]
∇

∇S ← E1 BETWEEN E2; e1; e2;X
 ⍝ POUR EXHIBER PLUS COURT CHEMIN ENTRE E1 ET E2
 X←E2
 →(∨/E1∊X)/END
 DEB: e1←USUCC E1
 e2←UPRED E2
 →(e1∊X)/END
 →(∧/(e1∊E1),e2∊E2)/NONE
 E1←e1
 E2←e2
 →DEB
 END: S←(e1∊e2)/e1
 →0
 NONE: S←⍳0
∇

∇BOUNDED;P;p;TR;M;m;A;a;B;b;C;c;L∆∆CPU;L∆∆CLASSES
 CLEARCONTEXT
 INITIME
 INICBOUND
 p←STEP0
 sk←,1
 →CHECKCONDITIONS/SUITE
 PAUSEMSG
 →0
 SUITE: ⍝ ENUMERATION DES ETATS DU RESEAU CHARGE.
 →(GOFROM 1)/LAB
 PAUSEMSG
 →0
 LAB:OKMSG
∇

∇K←BOUNDED1;V;W
 ⍝ TEST DITO KARP AMD MILLER'S
 W←REDUC V←st[1;PREDS]
 V←(ms[W;]∧.≤M)/W
 →(K←0=⍴V)/0
 →(K←0=⍴V←(ms[V;]∨.<m)/V)/0
 K←0,p,1↑V
∇

∇K ← BOUNDED2;V;W;PR;abc
 ⍝ m ≥ M AND M ≠ N AND d = D
 W←REDUC V←st[1;PR←PREDS]
 V←(ms[W;]∧.≤m)/W
 →(K←0=⍴V)/0
 →(K←0=⍴V←(ms[V;]∨.<m)/V)/0
 ⍝ V EST ENSEMBLE DE MARQUAGES AVEC M INFERIEURS
 ⍝ ABC DE MEME DIM EXISTE PARMI ETATS PREDS AVEC CES MARQUAGES ?
 →(K←0=⍴PR←(st[1;PR]∊V)/PR)/0
 →(K←0=⍴PR←(st[1;PR]=⍴a)/PR)/0
 ⍝ MEME ABC PARMI CES ETATS
 abc←,a,b,c
 →(0=⍴abc)/END
 W←st[2;P]∘.+¯1+⍳⍴abc
 W←((⍴PR),⍴abc)⍴id[,W]
 →(K←0=⍴PR←(W∧.=abc)/PR)/0
 END:K←0,p,1↑PR
∇

∇K←BOUNDED3
 ⍝ AVEC SEUILS
 'TEST D''ARRET NIVEAU 3 NON ENCORE IMPLANTE'
 ⍝ L∆BOUNDEDTESTLEVEL←2
 L∆BOUNDEDNESSTEST←2
 K←BOUNDED2
∇

∇K←BOUNDED4
 ⍝
 'TEST D''ARRET NIVEAU 4 NON ENCORE IMPLANTE'
 ⍝ L∆BOUNDEDTESTLEVEL←2
 L∆BOUNDEDNESSTEST←2
 K←BOUNDED2
∇

∇K←BOUNDEDTEST NUMBER
 →(1 2 3 4 =NUMBER)/E1,E2,E3,E4
 →0,K←1
 E1:→0,K←BOUNDED1
 E2:→0,K←BOUNDED2
 E3:→0,K←BOUNDED3
 E4:→0,K←BOUNDED4
∇

∇R←BREACHSET C;r
 ⍝ CLASSES DEPUIS LESQUELLES L'UNE DES CLASSES DE C EST ACCESSIBLE
 ⍝ UTILISE LES CFCMS
 R←,C
 DEB:r←REDUC R,(cc ∊(cc[R]≠0)/cc[R])/⍳⍴cc
 r←REDUC r,(∨/[2] sg[1;;]∊R)/⍳(⍴sg)[2]
 →(~(⍴r)=⍴R)/NEXT
 →0
 NEXT:R←r
 →DEB
∇

∇B←CBOUNDOVER LMT;X
 ⍝ 2023: L∆∆CLASSES=0 means no bound
 B←0
 →(0=L∆∆CLASSES)/0
 →(~B←(⍴st)[2]≥L∆∆CLASSES)/0
 L∆∆CLASSES←L∆∆CLASSES+LMT
∇

∇P←CFCMSPENDANTES;C;I;E;S
 ⍝ DETERMINE CFCMS PENDANTES
 P←⍳0
 C←C[⍋C←REDUC (cc≠0)/cc]
 I←1
 DEB: →(I>⍴C)/0
 E←(cc=C[I])/⍳⍴cc
 S←(S≠0)/S←,sg[1;E;]
 →(∧/S∊E)/LAB
 I←I+1
 →DEB
 LAB:P←P,C[I]
 I←I+1
 →DEB
∇

∇K←CHECKBOUNDED;W
 →(K←1↑W←BOUNDEDTEST L∆BOUNDEDNESSTEST)/0
 'CLASS ',(⍕W[2]),' FAILED BOUNDEDNESS TEST ',(⍕L∆BOUNDEDNESSTEST),' COMPARE CLASS ',⍕W[3]
 K←SOWHATNOW
∇

∇K←CHECKCBOUND
 →(K←~CBOUNDOVER L∆CLASSES)/0
 'OVERFLOW NUMBER OF CLASSES'
 TELLSTATES
 K←SOWHATNOW
∇

∇L ← CHECKCFCMS P;I
 L←(⍴P)⍴0
 I←1
 DEB:→(I>⍴P)/0
 L[I]←∧/(⍳(⍴tn)[1])∊sg[2;(cc=P[I])/⍳⍴cc;]
 I←I+1
 →DEB
∇

∇K←CHECKCONDITIONS
 ⍝ CHECKS SPECIFIC CONDITIONS IN L∆CONDITIONS
 K←1
 →(0=⍴L∆CONDITIONS)/0
 →(K←⍎L∆CONDITIONS)/0
 'CONDITION ',L∆CONDITIONS, ' VIOLATED'
 K←SOWHATNOW
∇

∇K←CHECKTIME
 →(K←~TIMEOVER L∆CPU)/0
 'OVERFLOW CPU TIME'
 TELLTIME
 K←SOWHATNOW
∇

∇CLASS N
 ⍝ DITO CLASSES
 CLASSES N
∇

∇CLASSES V;I;m;M
 ⍝ LIST PARTIEL ETATS
 M←0 0 ⍴''
 I←1
 →(~'*'∊V)/LAB
 V←(('*'=1↑V)/'1'),V,('*'=¯1↑V)/⍕(⍴st)[2]
 V[(V='*')/⍳⍴V]←' '
 V←⍎V
 V←V[1]+¯1+⍳1+V[2]-V[p1]
 →DEB
 LAB: V←,⍎V
 V←REDUC V[⍋V]
 DEB:→(I>⍴V)/FIN
 m←PRINTCLASS V[I]
 →(⎕PW≥1+(⍴M)[2]+(⍴m)[2])/SUITE
 ' '
 M
 M←0 0 ⍴''
 SUITE:M←M CONCAT2 ' ' CONCAT2 m
 I←I+1
 →DEB
 FIN:' '
 M
∇

∇CLEARCONTEXT
 tt←TIME
 ms←0 0⍴0
 st←4 0⍴0
 sg←4 0 0⍴0
 id←⍳0
 cc←⍳0
 sk←⍳0
 cg←2 0 0 ⍴0
∇

∇CLEARNET
 es← 2 0 0⍴0
 is←2 0 1 ⍴0
 m0←0⍴0
 pn←0 0⍴''
 tn←0 0⍴''
 nn←''
∇

∇T←T1 CONCAT T2
 ⍝ CONCATENE TABLEAUX A 3 PLANS SELON LIGNES.
 →((⍴T1)[3]>(⍴T2)[3])/SUP
 →((⍴T1)[3]=(⍴T2)[3])/EQ
 INF: T1←((⍳(⍴T2)[3])∊⍳(⍴T1)[3])\[3] T1
 →EQ
 SUP: T2←((⍳(⍴T1)[3])∊⍳(⍴T2)[3])\[3] T2
 EQ: T←T1,[2] T2
∇

∇T←T1 CONCAT1 T2
 ⍝ CONCATENE MATRICES SELON LIGNES
 T1←(¯2↑ 1 1 ,⍴T1)⍴,T1
 T2←(¯2↑ 1 1 ,⍴T2)⍴,T2
 →((⍴T1)[2]>(⍴T2)[2])/SUP
 →((⍴T1)[2]=(⍴T2)[2])/EQ
 INF: T1←((⍳(⍴T2)[2])∊⍳(⍴T1)[2])\[2] T1
 →EQ
 SUP: T2←((⍳(⍴T1)[2])∊⍳(⍴T2)[2])\[2] T2
 EQ:T←T1,[1] T2
∇

∇T←T1 CONCAT2 T2
 ⍝ CONCATENE MATRICES SELON COLONNES
 T1←(¯2↑ 1 1 ,⍴T1)⍴,T1
 T2←(¯2↑ 1 1 ,⍴T2)⍴,T2
 →((⍴T1)[1]>(⍴T2)[1])/SUP
 →((⍴T1)[1]=(⍴T2)[1])/EQ
 INF:T1←((⍳(⍴T2)[1])∊⍳(⍴T1)[1])\[1] T1
 →EQ
 SUP:T2←((⍳(⍴T1)[1])∊⍳(⍴T2)[1])\[1] T2
 EQ:T←T1,[2] T2
∇

∇W←CONTEXTSIZE
 W←(⍴id)+(×/⍴ms)+(×/⍴st)+(×/⍴sg)
∇

∇CONTINUE;P;p;TR;M;m;A;a;B;b;C;c;Q;L∆∆CPU;L∆∆CLASSES
 ⍝ POURSUIT L'ENUMERATION OU ARRETEE
 INITIME
 INICBOUND
 →(0=⍴sk)/LAB
 →(GOFROM ¯1↑sk)/LAB
 PAUSEMSG
 →0
 LAB:OKMSG
∇

∇S←E1 CPATH E2;E;X
 ⍝ EXTRACTS A C-PATH BETWEEN C-SETS E1 AND E2
 S←⍳0
 E←E1 BETWEEN E2
 →(0=⍴E)/0
 S←1↑(E1∊E)/E1
 E←(~E=S)/E
 DEB: →((¯1↑S)∊E2)/0
 X←1↑(E∊(,sg[1;¯1↑S;]≠0)/,sg[1;¯1↑S;])/E
 S←S,X
 E←(~E=X)E
 →DEB
∇

∇DT←DEADTRANSITIONS
 DT←(~(⍳(⍴tn)[1])∊sg[2;;])/⍳(⍴tn)[1]
∇

∇DELETENETS L
 ⍝ ERASES DEFINITIONS OF NETS IN L
 ⍝ UPDATES DIRECTORY OF NETS
 ERASES TABLEAUS OF NETS IN L
 ERASENETS L
 L ← nl_ nr_ L
 SYS∆NETS ← SYS∆NETS el_ L
 'DEFINITION(S) OF NET(S) ',(ln_ L),' ERASED'
 L ← ⎕EX L
∇

∇DROPOLDNET;M
 ⍝ DROP COPY OF OLD NET o
 M ← rd_ SYS∆VARSNETS
 M → ⎕EX M,[2]((⍴M)[1],1)⍴'0'
∇

∇ERASECONTEXT L;J;M
 ⍝ ERASE CONTEXTS OF NETS IN L
 M ← rd_ SYS∆VARSANA
 L ← nl_ nr_ L
 J ← ⎕EX L
 'CONTEXT(S) OF NET(S) ',(ln_ J/[1] L),' ERASED'
∇

∇ERASENETS L;J;M
 ⍝ ERASES TABLEAUS OF NETS IN L AND THEIR CONTEXTS
 ERASECONTEXT L
 M ← rd_ SYS∆VARSNETS
 L ← nl_ nr_ L
 J ← ⎕EX L
 'NET(S) ',(ln_ J/[1] L),' ERASED'
∇

∇EXEC MAT;I
 I ← 1
 DEB:→(I>(⍴MAT)[1])/0
 ⍎MAT[I;]
 I ← I+1
 →DEB
∇

∇PMD←FIND;X;W;E;abc
 PMD←0 0 0
 ⍝ EXISTE CLASSE AVEC MEME MARQUAGE ?
 X←(ms∧.=m)/⍳(⍴ms)[1]
 PMD[2]←1↑X,0
 ⍝ EXISTE DOMAINE AVEC MEME NOMBRE DE VARIABLES ?
 E←REDUC(st[3;]=⍴a)/st[2;]
 →(0=⍴E)/0
 ⍝ EXISTE CLASSE AVEC MEME DOMAINE ?
 PMD[3]←1↑E,0
 abc←a,b,,c
 →(0=⍴abc)/DEAD
 W←E∘.+¯1+⍳⍴abc
 W←((⍴E),⍴abc)⍴id[,W]
 W←(W∧.=abc)/E
 PMD[3]←1↑W,0
 →(0=⍴W)/0
DEAD:
 ⍝ EXISTE CLASSE AVEC MEME M ET D ?
 E←((⍉st[1 2;])∧.=PMD[2 3])/⍳(⍴st)[2]
 PMD[1]←1↑E,0
∇

∇FINDFIRABLE;KB;X
 ⍝ DETERMINE TIRABLES, CALCULE MINS, MAX ET MODIFIE tt
 MINS←a
 MAX←¯1
 →(0=⍴tt)/0
 X←(REDUC tt) ING tt
 →(∧/b<0)/LAB
 KB←(b≥0)/⍳⍴b
 MAX←⌊/b[KB]
 X←X∧(MINS≤MAX)∧∧/[1] c[KB;]≥0
 LAB:MINS←X/MINS
 tt←X/tt
∇

∇S←E1 FSEQ E2;T
 ⍝ SHORTEST FIRING SEQUENCE BETWEEN C-SETS E1 AND E2
 E1←⍎E1
 E2←⍎E2
 →(∨/(E1,E2)>(⍴sg)[2])/ERROR
 S←E1 CPATH E2
 →(0=⍴S)/NONE
 →((⍴S)>1)/LAB
 S←⍕S
 →0
 LAB:T←tn[TPATH S;]
 S←(⍕1↑S),' ',;ln_ (((⍴T)[1],4)⍴' -> '),[2] T,[2](((⍴T)[1],1)⍴'/'),[2]⍕((⍴T)[1],1)⍴1↓S
 →0
 NONE:'NO SUCH SEQUENCE'
 S←''
 →0
 ERROR:'CLASSE(S) ',(⍕(~(E1,E2)∊⍳(⍴st)[2])/E1,E2),' UNKNOWN'
 S←''
∇

∇C←GAMMAS P;X
 ⍝ DONNE MATRICE CONTRAINTES POUR ETAT P:
 C←0 0 ⍴0
 →(0=X←st[3;P])/0
 C←(X,X)⍴id[((2×X)+st[2;P]+¯1)+⍳X×X]
∇

∇K←GOFROM P
 M←MAR P
 A←ALPHAS P
 B←BETAS P
 C←GAMMAS P
 FWD: ⍝ STEP FORWARD, FIRES IF ANY THE FIRST
 ⍝ NOT YET FIRED TRANSITION FROM STATE P.
 →(~K←CHECKTIME)/0
 →(~K←CHECKCBOUND)/0
 ⍝ FIND THE FIRST TR:
 TR←NEXT P
 ⍝ CHECKS IF ANY, IF NONE STEP BACK:
 →(0=⍴TR)/BKW
 ⍝ FIRING TR FROM P, FILLS P WITH - INDEX STATE IF
 ⍝ REACHED STATE IS KNOWN, ITS STORAGE INDEX ELSE:
 p←STEP TR
 ⍝ IF STATE REACHED IS NEW, ENUMERATE FROM IT, ELSE
 ⍝ CARRY ON FROM THE CURRENT STATE:
 →(0≥p)/FWD
 sk←sk,p
 P←p
 M←m
 A←a
 B←b
 C←c
 →(~K←CHECKBOUNDED)/0
 →(~K←CHECKCONDITIONS)/0
 →(~K←CHECKTIME)/0
 →(~K←CHECKCBOUND)/0
 →FWD
 BKW: ⍝ STEPS BAK
 ⍝ CALLED WHEN ALL TRANSITIONS FIRABLE FROM
 ⍝ THE CURRENT STATE HAVE BEEN FIRED.
 sk←¯1↓sk
 →(0=⍴sk)/0
 P←¯1↑sk
 M←MAR P
 A←ALPHAS P
 B←BETAS P
 C←GAMMAS P
 →FWD
∇

∇HISTORY
 'Jan 2024: EXTRACTED FROM GNUAPL.apl TRANSCRIPTION OF SCANS'
∇

∇V←B1 IND B2;I;J;K
 ⍝ VECTEUR CAR. A DROITE DE B1 DANS B2
 V←(⍴B2)⍴0
 →((0=⍴B1)∨0=⍴B2)/0
 I←⍴V
 DEB: →(I≤0)/0
 K←B2[I]∊B1
 →(~K)/LAB
 V[I]←1
 J←B1⍳B2[I]
 B1←((J-1)↑B1),J↓B1
 LAB:I←I-1
 →DEB
∇

∇V←B1 ING B2;I;J;K
 ⍝ VECTEUR CAR. A GAUCHE DE B1 DANS B2
 V←(⍴B2)⍴0
 →((0=⍴B1)∨0=⍴B2)/0
 I←1
 DEB: →(I>⍴V)/0
 K←B2[I]∊B1
 →(~K)/LAB
 V[I]←1
 J←B1⍳B2[I]
 B1←((J-1)↑B1),J↓B1
 LAB:I←I+1
 →DEB
∇

∇INICBOUND
 L∆∆CLASSES←(⍴st)[2]+L∆CLASSES
∇

∇INICHECK
 INITIME
 L∆∆CPU←L∆CPU
 L∆∆STATES←L∆STATES
∇

∇INITIME
 L∆∆CPU←(TIME-tt)+L∆CPU
∇

∇V←M IOTA N;G
 ⍝ INDEX DES LIGNES DE M DANS N OU ZERO
 D←(⍴M)[1]
 V←1+D+((⍳D)-1+D)⌊.×M∧.=⍉N
∇

∇LIBNETS
 ,(((⍴SYS∆NETS)[2]⍴1),0)\[2] SYS∆NETS
∇

∇LIVE;P;L
 ⍝ TROUVER DEADLOCKS TOTAUX
 P←TOTALDEADLOCKS
 →(0≠⍴P)/NO
 ⍝ TROUVER CFCMS PENDANTES
 P←CFCMSPENDANTES
 ⍝ TESTER PRESENCE DE TOUTES LES
 ⍝ TRANSITIONS DANS CHAQUE CFCM PENDANTE
 L←CHECKCFCMS P
 →(~∧/L)/NO
 'LIVE',((⍴P)>1)/': ',(⍕⍴P),' PENDING CFCMS'
 →CY
 NO:'NOT LIVE (USE LIVEDIAGNOSIS FOR MORE INFORMATION)'
 CY:((~∧/cc=1)/'NOT '),'CYCLIC'
∇

∇LIVEDIAGNOSIS;TD;DT;X;P;DTT;E;LT
 'LIVENESS DIAGNOSIS:'
 ⍝ '(USE PRINTCFCMS FOR MORE ABOUT CFCMS)'
 ' '
 ⍝ PRINTS LIVENESS DIAGNOSIS
 TD←TOTALDEADLOCKS
 →(0=⍴TD)/SUITE
 X←(⍴TD)>1
 'CLASS',(X/'ES'),' ',(⍕TD),(X/' ARE'),((~X)/' IS A'),' TOTAL DEADLOCK',X/'S'
 ' '
SUITE: DT←DEADTRANSITIONS
 ⍝ DTT← TRANSITIONS QUASI VIVANTES
 DTT←(~DTT∊DT)/DTT←⍳(⍴tn)[1]
 →(0≠⍴TD)/END
 X←CHECKCFCMS P←CFCMSPENDANTES
 P←(X=0)/P
 X←1
 LT←DTT
DEB:→(X>⍴P)/END0
 LT←(LT∊sg[2;(cc=P[X])/⍳⍴cc;])/LT
 X←X+1
 →DEB
END0:DTT←(~DTT∊LT)/DTT
 X←1<⍴LT
 →(0=⍴LT)/END
 'TRANSITION',(X/'S '),(ln_ tn[LT;]),(X/' ARE '),((~X)/' IS '),'LIVE'
 ' '
END:X←1<⍴DT
 →(0=⍴DT)/END2
 'TRANSITION(S) ',(X/'S '),(ln_ tn[DT;]),(X/' ARE '),((~X)/' IS '),'DEAD FROM THE INITIAL CLASS'
END2: ⍝ DTT CONTIENT TRANSITIONS NON VIVANTES MAIS QUASIVIVANTES
 X←1
 DEB2: →(X>⍴DTT)/0
 E←PDEADLOCKFOR DTT[X]
 'TRANSITION ',tn[DTT[X];],' IS DEAD FROM CLASS',((1<⍴,E)/'ES'),' ',⍕E
 X←X+1
 →DEB2
∇

∇LOADCONTEXT NOM;MAT
 ⍝ CHARGE CONTEXTE RESEAU NOM
 LOADNET NOM
 MAT←SYS∆VARSANA,[2](SYS∆VARSANA)[1]⍴'←'
 MAT←MAT,[2](rd_ SYS∆VARSANA),[2]((⍴SYS∆VARSANA)[1],NOM)⍴NOM←nr_ NOM
 EXEC MAT
 'CONTEXT OF ',nn.' LOADED'
∇

∇LOADED
 nn,' LOADED'
 (⍕(⍴es)[3]),' PLACES, ',(⍕(⍴es)[2]),' TRANSITIONS'
∇

∇LOADMERGENET NOM
 'FUNCTION LOADMERGENET NOT YET IMPLEMENTED'
∇

∇LOADNET NOM;MAT
 CLEARCONTEXT
 MAT←SYS∆VARSNETS,[2](⍴SYS∆VARSNETS)[1]⍴'←'
 MAT←MAT,[2](rd_ SYS∆VARSNETS),[2]((⍴SYS∆VARSNETS)[1],⍴NOM)⍴NOM←nr_ NOM
 EXEC MAT
 nn←NOM
 NOM,' LOADED,'
 (⍕(⍴pn)[1]),' PLACES, ',(⍕(⍴tn)[1]),' TRANSITIONS.'
∇

∇V←M0DEF;J;KJ
 ⍝ BUILDS DEFINITION OF m0
 V←(m0≠0)/⍳⍴m0
 J←pn[V;]
 K←((⍴V),1)⍴m0[V]
 V←(K[;1]=1)/⍳(⍴K)[1]
 K←(((⍴K)[1],1)⍴'('),[2](⍕K),[2]((⍴K)[1],1)⍴')'
 K[V;]←' '
 V←J,[2] K,[2]((⍴K)[1],1)⍴','
 V←'M0= ',(V≠' ')/V←¯1↓,V
∇

∇cg←MAKECFCMSGRAPH;CC
 ⍝ MAKES GRAPH OFCFCMS
 ⍝ USES MAKECLASSES FROM BBAUTOMA PACKAGE
 CC←cc+(cc=0)×⍳⍴cc
 cg←(CC MAKECLASSES sg[2 1 ;;]) [2 1 ;;]
∇

∇M←C MAKECLASSES tg;V;t;s;J;N;T
 ⍝ C: VECTOR OF CLASSES.
 ⍝ RQ: LABELS NON TRAITES SI EXISTENT.
 M←tg
 →(∧/V←C=⍳⍴C)/0
 ⍝ CONVERSION INDEX ETATS:
 ⎕IO←0
 M[1;;]←(0,C)[M[1;;]]
 M[1;;]←(0,V\1+⍳+/V)[M[1;;]]
 ⎕IO←1
 ⍝
 t←s← 0 0 ⍴0
 J←⍳⍴C
 DEB:→(0=⍴J)/FIN
 V←(C=1↑J)/⍳⍴C
 J←(~J∊V)/J
 N←M[;V;]
 N←(2,×/1↓⍴N)⍴,N
 T←N[1;]≠0
 N←T/[2] N
 T←(N[1;]≠0)/N[1;]
 V←(⍳⍴T)∊T⍳T
 t←t CONCAT1 V/N[1;]
 s←s CONCAT1 V/N[2;]
 →DEB
 FIN:M←(2,⍴t)⍴(,t),,s
∇

∇K←MAKENET NOM;M;I;L
 K←1
 M← 1 0 ↓⎕CR NOM
 I←1
 DEB: →(I>(⍴M)[1])/END
 L←M[I;]       ⍝ with quotes
 L←(L≠'''')/L  ⍝ dropping quotes
 L←(L≠' ')/L   ⍝ dropping spaces
 I←I+1
 →('⍝'=1↑L,'⍝')/DEB
 →('→='∊L)/TRANS,MAR
 'LINE: ',L,' REJECTED'
 →DEB
 TRANS: ⍎'(t_''',(''') be_ (p_''|:' su_ ''') to_ p_''|→' su_ L),''''
 →DEB
 MAR: ⍎'ma_''',(3↓L),''''
 →DEB
 END:→(I>1)/0
 K←0
∇

∇M←MAR P
 ⍝ P: LISTE DE POINTEURS D'ETATS
 M←,ms[st[1;P];]
∇

∇N←NETDEF;I
 ⍝ BUILDS DEFINITION OF NETLOADED
 N←nn
 I←1
 DEB:→(I>(⍴tn)[1])/END
 N←N CONCAT1 TRANSDEF I
 I←I+1
 →DEB
 END: N←N CONCAT1 M0DEF
∇

∇T←NEXT P
 ⍝ GIVES FIRST TRANSITION NOT YET FIRED FROM
 ⍝ STATE P (MAY BE EMPTY):
 T←(,(sg[1;P;]=0)∧sg[2;P;]≠0)/,sg[2;P;]
 →(0=⍴T)/0
 T←1↑T
∇

∇NODE N
 ⍝ DITO NODES
 NODES N
∇

∇NODES V;I
 ⍝ LIST PARTIEL ETATS
 I←1
 →(~'*'∊V)/LAB
 V←(('*'=1↑V)/'1'),V,('*'=¯1↑V)/⍕(⍴st)[2]
 V[(V='*')/⍳⍴V]←' '
 V←⍎V
 V←V[1]+¯1+⍳1 +V[2]-V[1]
 →DEB
 LAB:V←,⍎V
 V←REDUC V[⍋V]
 DEB:→(I>⍴V)/0
 PRINTNODE V[I]
 I←I+1
 →DEB
∇

∇NODES2 V;I
 ⍝ LIST PARTIEL ETATS
 I←1
 →(~'*'∊V)/LAB
 V←(('*'=1↑V)/'1'),V,('*'=¯1↑V)/⍕(⍴cg)[2]
 V[(V='*')/⍳⍴V]←' '
 V←⍎V
 V←V[1]+¯1+⍳1 +V[2]-V[1]
 →DEB
 LAB:V←,⍎V
 V←REDUC V[⍋V]
 DEB:→(I>⍴V)/0
 PRINTNODE2 V[I]
 I←I+1
 →DEB
∇

∇NORMALIZE;A;B;C;XB
 ⍝ 13/10/83
 ⍝ CALCULE MINS ET MAXS EFFECTIFS
 XB←(b≥0)/⍳⍴b
 →(0=⍴XB)/END
 DEB:A←a
 B←b
 C←c
 SUBSTITUTE XB
 →(∨/A≠a)/DEB
 →(∨/B≠b)/DEB
 →(∨/,C≠c)/DEB
 END: c←c⌊b∘.-a
 XB←(b<0)/⍳⍴b
 c[XB;]←b[XB]∘.-a
 c←(¯1+⍳⍴b)⌽[2] c
 c[;1]←b-a
 c←(- ¯1+⍳⍴b)⌽[2] c
∇

∇OKMSG
 'BOUNDED'
 (⍕(⍴st)[2]),' STATE CLASSES'
 TELLTIME
∇

∇OPTIONS
 SETTIME
 SETCBOUND
 SETBOUNDEDNESSTEST
 SETCONDITIONS
∇

∇PAUSEMSG
 'ENUMERATION SUSPENDED, ENTER CONTINUE FOR MORE'
 (⍕(⍴st)[2]),' CLASSES ENUMERATED SO FAR.'
 TELLTIME
∇

∇e←PDEADLOCKFOR T;E
 ⍝ COMPUTES PARTIAL DEADLOCK SET FOR TR. T
 ⍝ I.E. CLASSES FROM WHICH (OR FROM THE SUCC. OF) T IS NOT FIRABLE.
 ⍝ E: CLASSES DEPUIS LESQUELLES T EST TIRABLE
 E←(∨/[2] sg[2;;]=T)/⍳(⍴sg)[2]
 ⍝ E ← BACKWARD REACHSET OF E
 E←BREACHSET E
 ⍝ e ← SUCCESSORS OF E NON IN E
 e←REDUC (,sg[1;E;]≠0)/,sg[1;E;]
 e←(~e∊E)/e
∇

∇PLACES
 ⎕PW ct_ fl_ pn
∇

∇P← PN PLDEF W
 P←((⍴W)⍴'×'),[2]⍕W
 P[(W[;1]=1)/⍳(⍴W)[1];]←' '
 P←¯1↓,PN,[2] P,[2](⍴W)⍴','
 P←(P≠' ')/P
∇

∇P←PREDS;X
 ⍝ CALCULE PREDECESSEURS DU SOMMET COURANT
 X←cc[sk]=0
 P←(X/sk),(cc∊cc[(~X)/sk])/⍳⍴cc
∇

∇PRINTCFCMS;CG;I;K;X;CC
 ⍝ PRINTS GRAPH OF CFCMS AND CFCMS
 ⍝ ' '
 'GRAPH OF CFCMS:'
 CG←MAKECFCMSGRAPH
 NODES2⍕⍳(⍴CG)[2]
 ' '
 'CONTENTS OF CFCMS:'
 CC←REDUC((cc=0)×⍳⍴cc)+cc
 I←1
 DEB:→(I>⍴CC)/0
 K←CC[I]
 →(0=cc[K])/LAB
 K←(cc=CC[I])/⍳⍴cc
 LAB:X←(⍴,K)>1
 'G',(⍕I),' CONTAINS CLASS',(X/'ES'),' ',⍕,K
 I←I+1
 →DEB
∇

∇M←PRINTCLASS I;J
 ⍝ I EST INDEX CLASSE
 M←'CLASS C',((' '≠J)/J←⍕I),':'
 M←M CONCAT1 'M = ' CONCAT2(L∆PRINT-4) PRINTMAR I
 ⍝ 2023 fixes dead bug
 →(0=⍴(ALPHAS I))/0
 M←M CONCAT1 'I : ' CONCAT2(L∆PRINT-4) PRINTDOM I
∇

∇T←PRINTCLASSES
 ' '
 'LIST OF STATE CLASSES:'
 CLASSES⍕⍳(⍴st)[2]
∇

∇M←F PRINTDOM I;J;K;L;A;B;C;T;V;NAM;W
 ⍝ AFFICHAGE DOMAINE
 A←ALPHAS I
 B←BETAS I
 C←GAMMAS I
 T←TS2 MAR I
 M← 0 0 ⍴''
 →(0=⍴A)/0
 ⍝ CALCUL INSTANTIATIONS
 V←+/[1] T∘.=REDUC T
 W←⍉(⍳J←⌈/V)∘.≤V
 W←(W≠0)/W←,W×V←(⍴W)⍴⍳J
 NAM←((J,1)⍴'.'),[2] rg_⍕|(J,1)⍴⍳J
 NAM←' ' CONCAT1 1 0 ↓NAM
 NAM←rg_(rd_ tn[T;]),[2] rg_ NAM[W;]
 ⍝ CONTRAINTES SIMPLES
 J←1
 DEB:→(J>⍴T)/DEB2
 L←nr_(⍕A[J]),' ≤ ',NAM[J;],(¯1≠B[J])/' ≤ ',⍕B[J]
 ⍝ L←nr_(⍕A[J]),' ≤ ',NAM[J;],(0≤B[J])/' ≤ ',⍕B[J]
 M←M CONCAT1 F ct_ L
 J←J+1
 →DEB
 DEB2: ⍝ CONTRAINTES COMPLEXES
 K←,⍉(⍴C)⍴⍳⍴A
 K←K CONCAT1,(⍴C)⍴⍳⍴A
 V←~(B[K[1;]]<0)∨(B[K[1;]]-A[K[2;]])≤,C
 K←V/[2] K,[1],C
 J←1
 DEB3:→(J>(⍴K)[2])/0
 L←nr_ NAM[K[1;J];],' - ',NAM[K[2;J];],' ≤ ',⍕K[3;J]
 M←M CONCAT1 F ct_ L
 J←J+1
 →DEB3
∇

∇PRINTGRAPH
 ' '
 'GRAPH OF STATE CLASSES:'
 NODES⍕⍳(⍴st)[2]
∇

∇V←F PRINTMAR J;K;M
 ⍝ AFFICHE MARQUAGE J, new version, M0DEF like
 M←MAR J
 V←(M≠0)/⍳⍴M
 J←pn[V;]
 K←((⍴V),1)⍴M[V]
 V←(K[;1]=1)/⍳(⍴K)[1]
 K←(((⍴K)[1],1)⍴'('),[2](⍕K),[2]((⍴K)[1],1)⍴')'
 K[V;]←' '
 V←J,[2] K,[2]((⍴K)[1],1)⍴','
 V←(V≠' ')/V←¯1↓,V
∇

∇PRINTNETDEF
 ⍝ PRINTS DEFINITION OF NET LOADED
 'NET LOADED IS: '
 ' '
 NETDEF
∇

∇N←PRINTNODE I;REC;T;M;L;J
 N← 0 0⍴''
 →(I>1)/DEB
 →(0=⍴TS m0)/DEB
 REC←⌊/,is[1;TS m0;]    ⍝ assumes shift enabled ...
 →(REC≤0)/DEB
 →(0=L∆SHIFT)/DEB       ⍝ REC is local, so unused in caller
 N←N CONCAT1 '→ (⍴=', (⍕REC),')/C1'
 DEB:→(I>(⍴sg)[2])/0
 L←⍳0
 J←1
 DEB1:→(J>(⍴sg)[3])/END1
 →(0=sg[2;I;J])/END1
 L←L,', (',(nr_ tn[sg[2;I;J];]),'∊[',(⍕sg[3;I;J]),','
 L←L,((st[4;I]≥0)/⍕st[4;I]),((st[4;I]<0)/'⍵'),']'
 L←L,')',((sg[4;I;J]≠0)/'/(⍴=',(⍕sg[4;I;J]),')'),'/?'
 →(0=sg[1;I;J])/E1
 L←(¯1↓L),'C',⍕sg[1;I;J]
 E1: J←J+1
 →DEB1
 END1: N←N CONCAT1 ⎕PW ct_('C',(⍕I),' →'),1↓L
∇

∇N←PRINTNODE2 I;T;M;L;J
 N← 0 0⍴''
 →(I>(⍴CG)[2])/0
 L←⍳0
 J←1
 DEB1: →(J>(⍴CG)[3])/END1
 →(0=CG[2;I;J])/END1
 L←L,', ',(nr_ tn[CG[2;I;J];]),'/G',⍕CG[1;I;J]
 J←J+1
 →DEB1
 END1: ⍝ 2023: fixes bug case L empty (popped up on e.g. TESTTB with multi=1)
 N←('G',(⍕I),' → ')
 →(0=⍴L)/0
 N←N CONCAT2(⎕PW-4+⍴⍕I) ct_,2↓L
∇

∇K←PSAFE
 ⍝ CHECKS PSAFENESS
 →(K←∧/m≤1)/0
 'CLASS ',(⍕p),' FAILED PSAFE CONDITION'
∇

∇R←REACHSET C;r
 ⍝ CLASSES ACCESSIBLES DEPUIS C
 ⍝ UTILISE LES CFCMS
 R←,C
 DEB: r←REDUC R,(cc∊(cc[R]≠0)/cc[R])/⍳⍴cc
 r←REDUC r,((,sg[1;r;])≠0)/,sg[1;r;]
 →(~(⍴r)=⍴R)/NEXT
 →0
 NEXT:R←r
 →DEB
∇

∇READMERGENET NOM
 ⍝ READS DEF OF NET NOM AND MERGES WITH NET LOADED
 SAVEOLDNET
 CLEARCONTEXT
 →(~MAKENET NOM)/END
 SYS∆NETS←SYS∆NETS al_ NOM
 NOM,' MERGED WITH ',nn,' UNDER NAME: ',nn,NOM
 (⍕(⍴pn)[1]),' PLACES, ',(⍕(⍴tn)[1]),' TRANSITIONS.'
 'DEFINITION OF NET ',nn,NOM,' CAN BE SAVED USING SAVENETDEF'
 DROPOLDNET
 nn←nn,NOM
 →0
 END:'DEFINITION ABORTED'
 RESTAUREOLDNET
∇

∇READNET NOM
 CLEARCONTEXT
 CLEARNET
 →(~MAKENET NOM)/END
 NOM,' LOADED,'
 nn←NOM
 SYS∆NETS←SYS∆NETS al_ NOM
 (⍕(⍴pn)[1]),' PLACES, ',(⍕(⍴tn)[1]),' TRANSITIONS.'
 →0
 END:'DEFINITION ABORTED'
 CLEARNET
∇

∇RECALE;XB
 ⍝ CALCULE REC, MODIFIE a, b et c
 REC←0
 ⍝ skip if shift option disabled
 →(0=L∆SHIFT)/0
 →(0=⍴a)/0
 REC←⌊/a
 →(REC≤0)/0
 a←a-REC
 XB←(b≥0)/⍳⍴b
 →(0=⍴XB)/END
 b[XB]←b[XB]-REC
 END:XB←(b<0)/⍳⍴b
 c[XB;]←b[XB]∘.-a
∇

∇V←REDUC E
 V←((⍳⍴E)∊E⍳E)/E
∇

∇R←REDUC2 L
 ⍝ REDUCTION MATRICE L (SUPPRIME LIGNES REPETEES)
 R←((⍳(⍴L)[1])∊L IOTA L)/[1] L
∇

∇RENAMENET NOM
 ⍝ RENAMES LOADED NET
 nn,' RENAMED ',NOM
 nn←NOM
∇

∇RESTAUREOLDNET;MAT
 MAT←SYS∆VARSNETS,[2]((⍴SYS∆VARSNETS)[1],1)⍴'←'
 MAT←MAT,[2](rd_ SYS∆VARSNETS),[2]((⍴SYS∆VARSNETS)[1],1)⍴'0'
 EXEC MAT
 nn,' RESTAURED'
∇

∇SAVECONTEXT;MAT
 SAVENET
 MAT←(rd_ SYS∆VARSANA),[2]((⍴SYS∆VARSANA)[1],⍴nn)⍴nn
 MAT←MAT,[2](((⍴MAT)[1],1)⍴'←'),[2] SYS∆VARSANA
 EXEC MAT
 'CONTEXT OF ',nn,' SAVED'
∇

∇SAVENET;MAT
 MAT←(rd_ SYS∆VARSNETS),[2]((⍴SYS∆VARSNETS)[1],⍴nn)⍴nn
 MAT←MAT,[2](((⍴MAT)[1],1)⍴'←'),[2] SYS∆VARSNETS
 EXEC MAT
 nn,' SAVED'
 SAVENETDEF
∇

∇SAVEOLDNET;MAT
 ⍝ SAVE TEMPORARILY LOADED NET
 MAT←(rd_ SYS∆VARSNETS),[2]((⍴SYS∆VARSNETS)[1],1)⍴'o'
 MAT←MAT,[2](((⍴MAT)[1],1)⍴'←'),[2] SYS∆VARSNETS
 EXEC MAT
∇

∇SETBOUNDEDNESSTEST;V
 ⍝ SETS L∆BOUNDEDNESSTEST
 V←'BOUNDEDNESS TEST IS ',(⍕L∆BOUNDEDNESSTEST),'; ENTER NEW VALUE (0≤v≤4) OR RETURN: '
 V←(⍴V)↓⍞,0/⍞←V
 →(0=⍴V)/0
 L∆BOUNDEDNESSTEST←1↑⍎V
∇

∇SETCBOUND;V
 ⍝ SETS L∆CLASSES
 V←'NUMBER OF CLASSES INCREMENT IS ',(⍕L∆CLASSES),'; ENTER NEW VALUE OR RETURN: '
 V←(⍴V)↓⍞,0/⍞←V
 →(0=⍴V)/0
 L∆CLASSES←1↑⍎V
∇

∇SETCONDITIONS;V;pw
 ⍝ SETS L∆CONDITIONS
 pw←⎕PW
 ⎕PW←256
 V←'CONDITION IS ',((0=⍴L∆CONDITIONS)/'EMPTY'),L∆CONDITIONS,'; ENTER NEW CONDITION (ONE OF TSAFE,PSAFE,EMPTY) OR RETURN: '
 V←(⍴V)↓⍞,0/⍞←V
 ⎕PW←pw
 →(0=⍴V)/0
 →((5=⍴V)∧∧/(5↑V='EMPTY'))/E1
 L∆CONDITIONS←V
 →0
 E1:L∆CONDITIONS←''
∇

∇SETTIME;V
 ⍝ SETS L∆CPU
 V←'CPU TIME INCREMENT IS ',(⍕L∆CPU),'; ENTER NEW VALUE OR RETURN: '
 V←(⍴V)↓⍞,0/⍞←V
 →(0=⍴V)/0
 L∆CPU←1↑⍎V
∇

∇B←SOWHATNOW;X
 ⍝ 2024 -- die if scripting
 →(0=L∆SCRIPTING)/ASK
 'KILLED'
 ⍎')off'
ASK:X←29↓⍞,⍞←'CONTINUE (C) OR PAUSE (P) ?: '
 B←'C'=1↑X
∇

∇p←STEP TR;tt;REC;PMD;MINS;MAX
 ⍝ TIR: CALCULE m, a, b, c ET tt
 TIR
 ⍝ RECALE: CALCULE REC, MODFIE a, b ET c
 RECALE
 ⍝ RECHERCHE CLASSE EGALE
 PMD←FIND
 →(PMD[1]≠0)/OLD
 ⍝ CALCULE MINS, MAX, MODIF tt
 FINDFIRABLE
 ⍝ STOCKAGE NOUVELLE CLASSE
 p←STORECLASS 1↓PMD
 P ADDNEXT p
 →END
 OLD: P ADDNEXT PMD[1]
 p← -PMD[1]
 END:P UPDATECFCM p
∇

∇p←STEP0;MINS;MAX;tt;REC
 ⍝ VALEURS PAR DEFAUT ET CALCUL tt
 a←0⍴0
 b←0⍴0
 c←0 0⍴0
 m←m0
 MINS←⍳0
 MAX←¯1
 tt←TS2 m
 →(0=⍴tt)/ST0
 ⍝ CALCUL a,b,c INITIAUX ET RECALAGE
 a←,is[1;tt;]
 b←,is[2;tt;]
 c←b∘.-a
 ⍝ RECALAGE, CALCULE REC
 RECALE
 ⍝ CALCUL TIRABLES, MINS, MAX, tt
 FINDFIRABLE
 ST0: ⍝ STOCKAGE ETAT INITIAL
 p←STOREINITIALCLASS
 cc←,0
∇

∇p←STORECLASS MD
 ⍝ STORAGE CLASS
 →(0≠MD[1])/E1
 ms←ms,[1] m
 MD[1]←(⍴ms)[1]
 E1:→(0≠MD[2])/E2
 MD[2]←1+⍴id
 id←id,a,b,,c
 E2:st←st,[2] MD,(⍴a),MAX
 sg←sg CONCAT(4 1 ,(⍴tt))⍴((⍴tt) ⍴0),tt,MINS,(⍴tt)⍴0
 ⍝ ⎕←(⍴st)[2]
 p←(⍴st)[2]
∇

∇p←STOREINITIALCLASS
 st← 4 1 ⍴ 1 1,(⍴a),MAX
 ms←(1,⍴m)⍴m
 sg←(4 1 , ⍴tt)⍴((⍴tt) ⍴0),tt,MINS,(⍴tt)⍴0
 id←a,b,,c
 p←1
∇

∇SUBSTITUTE V;K;XB
 ⍝ SUBSTITUE VARS D'INDEX V DANS a,b ET c
 ⍝ CONSERVE DIMENSIONS a, b ET c
 XB←(b≥0)/⍳⍴b
 V←(V∊XB)/V
 DEB: →(0=⍴V)/0
 K←1↑V
 a←a⌈a[K]-,c[K;]
 ⍝ 2023 fix for trains*e (unbounded lft)
 ⍝ was: b←b⌊b[K]+,c[;K]
 ⍝ now:
 b[XB]←b[XB]⌊b[K]+,c[XB;K]
 c[XB;]←c[XB;]⌊(,c[XB;K])∘.+,c[K;]
 V←1↓V
 →DEB
∇

∇TELLSTATES
 (⍕(⍴st)[2]),' CLASSES ENUMERATED'
∇

∇TELLTIME
 'CPUT = ',(⍕TIME-tt),'S'
∇

∇D←TIME
 D←⎕AI[2]÷1000
∇

∇B←TIMEOVER LMT;X
 ⍝ 2023: L∆∆CPU=0 means no bound
 B←0
 →(0=L∆∆CPU)/0
 →(~B←(TIME-tt)≥L∆∆CPU)/0
 L∆∆CPU←L∆∆CPU+LMT
∇

∇TIR;TSR;TSE;TT;X;XB;K;SUP
 ⍝ REMPLIT m,a,b,c,tt: TIRE TR  DEPUIS ETAT P
 ⍝ CALCUL NOUVEAU MARQUAGE ET TESTS
 m←(M-,es[1;TR;])+,es[2;TR;]
 a←0⍴0
 b←0⍴0
 c← 0 0 ⍴0
 ⍝ CALCUL NOUVELLEMENT SENSIBILISEES
 tt←TS2 m
 →(0=⍴tt)/0
 ⍝ CALCUL RESTANTES ET TEST
 TSR←TS2 M-,es[1;TR;]
 ⍝ 2023 fixes omegab when multi=0 (fired tr must be excluded from TSR)
 ⍝ not sure that treatment is correct if multi is set ...
 →(L∆MULTI)/SKIP
 TSR←(TSR≠TR)/TSR
 SKIP: →(0=⍴TSR)/E2
 TT←TS2 M
 ⍝ DECALAGE
 E3: XB←(B≥0)/⍳⍴B
 K←TT⍳TR
 SUP←st[4;P]
 a←0⌈(SUP≥0)×((B[K]≥0)×,-C[K;])⌈A-SUP
 b←B
 c←C
 →(0=⍴XB)/E4
 b[XB]←(,C[XB;K])⌊B[XB]-A[K]
 c[XB;]←C[XB;]⌊B[XB]∘.-A
 →((⍴XB)=⍴a)/LAB2
 c[X;]←((⍴a)⍴¯1)[X←(B<0)/⍳⍴B]∘.-a
 LAB2:X←(⍴c)⍴1,(⍴a)⍴0
 c[XB;]←c[XB;]+X[XB;]×(b[XB]∘.-a)-C[XB;]
 ⍝ ELIMINATUON SORTANTES
 E4:SUBSTITUTE (~X←TSR IND TT)/⍳⍴TT
 a←X/a
 b←X/b
 c←X/[1] X/[2] c
 ⍝ NORMALISATION
 NORMALIZE
 ⍝ ADJONCTION ENTRANTES
 E2:X←TSR ING tt
 a←X\a
 b←X\b
 c←X\[1] X\[2] c
 TSE←(~X)/tt
 X←(~X)/⍳⍴X
 a[X]←,is[1;TSE;]
 b[X]←,is[2;TSE;]
 c[X;]←b[X]∘.-a
 c[;X]←b∘.-a[X]
 ⍝ CHECK POINT
∇

∇TD←TOTALDEADLOCKS
 TD←(∧/[2] sg[2;;]=0)/⍳(⍴sg)[2]
∇

∇F←TPATH C
 ⍝ FIRING SEQUENCE FOR C-PATH C
 F←(,sg[1;¯1↓C;]=⍉(⌽ ⍴sg[1;¯1↓S;])⍴1↓S)/,sg[2;¯1↓S;]
∇

∇T←TRANSDEF I
 ⍝ BUILDS DEFINITION OF TRANSITION I OF NET LOADED
 ⍝ 2023 fix (removing extra :), was:
 ⍝ T←'[',(⍕is[1;I;]),',',((is[2;I;]<0)/'⍵'),((is[2;I;]≥0)/⍕is[2;I;]),']:'
 ⍝ now:
 T←'[',(⍕is[1;I;]),',',((is[2;I;]<0)/'⍵'),((is[2;I;]≥0)/⍕is[2;I;]),']'
 T←tn[I;],((is[1;I;]≠0)∨is[2;I;]≠¯1)/T
 T←(T≠' ')/T
 T←T,': ',((es[1;I;]≠0)/[1] pn) PLDEF ⍉(es[1;I;]≠0)/[2] es[1;,I;]
 T←T,' → ',((es[2;I;]≠0)/[1] pn) PLDEF ⍉(es[2;I;]≠0)/[2] es[2;,I;]
∇

∇TRANSITIONS
 ⎕PW ct_ fl_ tn
∇

∇T←TS M
 ⍝ M EST UN VECTEUR
 T←(es[1;;]∧.≤M)/⍳(⍴es)[2]
∇

∇B←TS2 M;V;T 
 ⍝ BAG DES TRANSITIONS SENSEBILISEES
 B←⍳0
 T←TS M
 →(0=⍴T)/0
 ⍝ 
 ⍝ 2023 a tester/finir: if L∆MULTI=0, return REDUC B (or TS M ?), whether ⍵-enabled or not
 ⍝
 B←T
 →(0=L∆MULTI)/0   ⍝ wrong for trains3e ?
 V←es[1;T;]
 M←(((⍴V)⍴M)×V≠0)+(⌈/M)×V=0
 V←⌊/[2]⌊M÷(V=0)+V
 ⍝ (statement moved:)
 B←T
 →(∧/V≤1)/0
 V←,⍉(((⌈/V),⍴T) ⍴T)×⍉V∘.≥⍳⌈/V
 B←(V≠0)/V
∇

∇K←TSAFE
 ⍝ CHECKS TSAFENESS
 →(K← ~∨/(2×es[1;;])∧.≤m)/0
 'CLASS ',(⍕p),' FAILED TSAFE CONDITION'
∇

∇P UPDATECFCM p;I;V;W
 ⍝ CALCUL INCREMENTAL CFCMS
 →(p>0)/NEW
 p← -p
 →(P=p)/SAME
 ⍝ p ANCIEN
 →(cc[p]=0)/LAB
 ⍝ p APPARTIENT A UNE CFCM
 I←cc[sk]⍳cc[p]
 →GO
 LAB:I←sk⍳p
 GO: →(I>⍴sk)/0
 V←(I-1)↓sk
 W←cc[V]=0
 V←(W/V),(cc∊cc[(~W)/V])/⍳⍴cc
 cc[V]←⌊/V
 →0
 SAME:cc[(⍳⍴cc)⍳P]←P   ⍝ check P ...
 →0
 NEW:cc←cc,0
∇

∇S←UPRED E
 ⍝ E UNION PRED E DANS sg
 S←REDUC E,(∨/[2] sg[1;;]∊E)/⍳(⍴sg)[2]
∇

∇S←USUCC E
 ⍝ E UNION SUCC E DANS sg
 S←REDUC E,(,sg[1; E;]≠0)/,sg[1; E;]
∇

∇WRITENET
 ⍝ BUILDS AND SAVES DEFINITION OF NET
 ⍝ USEFUL WHEN NET IS BUILT USING MERGE
 'DEFINITION OF ',(⎕FX NETDEF),' SAVED'
 SYS∆NETS←SYS∆NETS el_((⍴nn),1)⍴nn
 SYS∆NETS←SYS∆NETS CONCAT1 nn
∇

∇R←L al_ L1
 ⍝ AJOUTE L1 A MATRICE L
 R←REDUC2 L CONCAT1 L1
∇

∇TM be_ ES;M;N;TN
 ⍝ UPDATE tn, es, is
 TN←TM[1;;]
 TN←(∨/[1] TN≠' ')/[2] TN
 M←tn CONCAT1 TN
 TN←M[(-(⍴TN)[1])↑⍳(⍴M)[1];]
 tn←M[REDUC M IOTA M;]
 V←(⍳(⍴tn)[1])∊⍳(⍴es)[2]
 es←V\[2] es
 is←V\[2] is
 V←tn IOTA TN
 ES←(2,(⍴TN)[1],(⍴ES)[3])⍴(,((⍴TN)[1],(⍴ES)[3])⍴,ES[1;;]),,((⍴TN)[1],(⍴ES)[3])⍴,ES[2;;]
 es[;V;]←es[;V;]+ES
 is[;V;]←(2,(⍴TM)[2],1)⍴⍎,TM[2 3 ;;],[3](2,(⍴TM)[2],1)⍴' '
 ⍝ CHECK POINT
∇

∇M←X ct_ L;U;V
 ⍝ FORMATTE LIGNE EN MATRICE LARGEUR X,
 ⍝ L EST NORMALISEE.
 X←1⌈X
 M←(0,X)⍴''
 V←(¯1+(L=' ')/⍳⍴L),⍴L
 DEB:→(0=⍴L)/0
 U←(V≤X)/V
 U←(U≥0)/U
 →(0=⍴U)/LAB
 M←M,[1] X↑(U←¯1↑U)↑L
 L←(U+1)↓L
 V←V-U+1
 →DEB
 LAB:M←M,[1] X↑L
 L←X↓L
 V←V-X
 →DEB
∇

∇R←L el_ L1
 ⍝ SUPPRIME L1 DE MATRICE L
 R←L
 →((⍴L1)[2]>(⍴L)[2])/0
 L1←((⍳(⍴L)[2])∊⍳(⍴L1)[2])\[2] L1
 R←(~(⍳(L)[1])∊L IOTA L1)/[1] L
∇

∇L← ln_ MAT
 ⍝ MATRICE DE NOMS → LISTE DE NOMS
 L←nr_,MAT,[2](⍴MAT)[1]⍴' '
∇

∇ma_ PV;M;V;K;PN
 ⍝ ANALYSE LEXICALE ET STOCKAGE MARQUAGE INITIAL.
 PV←(PV≠' ')/PV
 PV[(PV=',')/⍳⍴PV]←' '
 PV←nl_ PV
 V←(∧/[2] PV≠'(')/⍳(⍴PV)[1]
 M←,PV
 M[(M∊'()')/⍳⍴M]←' '
 PV←(⍴PV)⍴M
 M←((⍴PV)[1],2)⍴' '
 M[V;2]←'1'
 PV←PV,[2] M
 M←sp_ PV
 PN←M[1;;]
 PN←(∨/[1] PN≠' ')/[2] PN
 K←pn CONCAT1 PN
 pn←K[REDUC K IOTA K;]
 PN←K[(-(⍴PN)[1])↑⍳(⍴K)[1];]
 K←(⍳(⍴pn)[1])∊⍳(⍴es)[3]
 es←K\[3] es
 m0←K\m0
 K←pn IOTA PN
 m0[K]←m0[K]+⍎ln_ M[2;;]
∇

∇M←nl_ L;DML;FML;DMW;FMW;X;N;W1;W2;U
 ⍝ FORMATTE LISTE DE MOTS SEPARES PAR UN BLANC EN
 ⍝ MATRICE AVEC UN MOT PAR LIGNE CALE A GAUCHE
 DML←((' ',L)=' ')/⍳⍴' ',L
 FML←(((L,' ')=' ')/⍳⍴L,' ')-1
 N←⍴DML
 X←⌈/U←1+FML-DML
 DMW←1+X×+¯1+⍳N
 FMW←U+DMW
 W1←(1+N×X)⍴0
 W1[DMW]←1
 W2←(1+N×X)⍴0
 W2[FMW]←1
 M←(N,X)⍴(¯1↓(+\W1)≠+\W2)\(L≠' ')/L
∇

∇S←nr_ L
 ⍝ NORMALISE BLANCS.
 S←(∨\L≠' ')/L
 S←(⌽ ∨\⌽ S≠' ')/S
 L←S≠' '
 S←(L∨1↓1⌽ 1,L)/S
∇

∇M←p_ PV;V
 ⍝ ANALYSE LEXICALE LISTE DE PLACES.
 PV←,PV
 M←2 0 0 ⍴''
 →(0=⍴PV)/0
 PV[(PV=',')/⍳⍴PV]←' '
 PV←nl_ PV
 V←(∧/[2] PV≠'×')/⍳(⍴PV)[1]
 M←,PV
 M[(M='×')/⍳⍴M]←' '
 PV←(⍴PV)⍴M
 M←((⍴PV)[1],2)⍴' '
 M[V;2]←'1'
 PV←PV,[2] M
 M←sp_ PV
 ⍝ CHECK POINT
∇

∇M←rd_ T
 ⍝ RECALE MATRICE T A DROITE
 M←(-(⍴T)[2]-⌈/[2](T≠' ')×(⍴T)⍴⍳(⍴T)[2])⌽ [2] T
∇

∇M←rg_ T
 ⍝ RECALE MATRICE T A GAUCHE
 M←(¯1+⌊/[2]((T=' ')×(⍴T)[2])+(T≠' ')×(⍴T)⍴⍳(⍴T)[2])⌽ [2] T
∇

∇T←sp_ M
 ⍝ X MOTS PAR LIGNE DANS M;
 ⍝ T: TABLEAU A X PLANS AVEC MOTS SEPARES.
 T←nl_ nr_,M,[2]((⍴M)[1],1)⍴' '
 T← 2 1 3 ⍉ ((⍴M)[1],((⍴T)[1]÷(⍴M)[1]),(⍴T)[2])⍴T
∇

∇V←AB su_ L;A;B;X;Y
 ⍝ SUBSTITUTION, AB FORMAT '(A|B)'.
 V←AB ⍳ '|'
 A←(V-1)↑AB
 B←(V-⍴AB)↑AB
 Y←(∧/[1](¯1+⍳⍴B)⌽ B∘.=L)/⍳⍴L
 V←L
 →(0=⍴Y)/0
 V←⍳0
 DEB:→(0=⍴Y)/END
 X←¯1↑Y
 Y←¯1↓Y
 V←A,((⍴B)↓(¯1+X-⍴L)↑L),V
 L←(X-⍴L)↓L
 →DEB
 END:V←((X-1)↑L),V
∇

∇M←t_ TV;V
 ⍝ ANALYSE LEXICALE LISTE DE TRANSITIONS.
 TV←,TV
 V←~(+\TV='[')-+\TV=']'
 V←V∧TV=','
 TV[V/⍳⍴TV]←' '
 TV←'¯1|⍵' su_ TV
 TV←nl_ TV
 V←(∧/[2] TV≠'[')/⍳(⍴TV)[1]
 M←,TV
 M[(M∊'[,]')/⍳⍴M]←' '
 TV←(⍴TV)⍴M
 M←((⍴TV)[1],5)⍴' '
 M[V;]←((⍴V),5)⍴' 0 ¯1'
 TV←TV,[2] M
 M←sp_ TV
 ⍝ CHECK POINT
∇

∇ES←N1 to_ N2;W1;W2;M;K
 ⍝ UPDATE pn, PRODUIT LIGNE DE ES
 W1←1↓⍎,'0 ',ln_ N1[2;;]
 N1←N1[1;;]
 N1←(∨/[1] N1≠' ')/[2] N1
 W2←1↓⍎,'0 ',ln_ N2[2;;]
 N2←N2[1;;]
 N2←(∨/[1] N2≠' ')/[2] N2
 M←pn CONCAT1 N1 CONCAT1 N2
 N2←M[(-(⍴N2)[1])↑⍳(⍴M)[1];]
 N1←M[(⍴N1)[1]↑(-(⍴N1)[1]+(⍴N2)[1])↑⍳(⍴M)[1];]
 pn←M[REDUC M IOTA M;]
 es←(K←(⍳(⍴pn)[1])∊⍳(⍴es)[3])\[3] es
 m0←K\m0
 ES←(2 1 ,(⍴pn)[1])⍴0
 ES[1;;pn IOTA N1]←W1
 ES[2;;pn IOTA N2]←W2
 ⍝ CHECK POINT
∇

N←' '
  N←0 0⍴N

⎕CT←1E¯13

⎕FC←6⍴(,⎕UCS 46 44 8902 48 95 175)

⎕IO←1

⎕L←0

⎕LX←' '
  ⎕LX←0⍴⎕LX

⎕PP←10

⎕PR←' '

⎕PS←0

⎕PW←120

⎕R←0

⎕RL←16807

⎕TZ←1

⎕X←0

